summaryrefslogtreecommitdiffstatshomepage
path: root/ui-summary.h
blob: c01f56012dcdcd64f39f6935c20eb5d18efb1b33 (plain)
1
2
3
4
5
6
7
#ifndef UI_SUMMARY_H
#define UI_SUMMARY_H

extern void cgit_print_summary();
extern void cgit_print_repo_readme(char *path);

#endif /* UI_SUMMARY_H */
61717; background-color: #e3d2d2 } /* Error */ .highlight .k { color: #008800; font-weight: bold } /* Keyword */ .highlight .ch { color: #888888 } /* Comment.Hashbang */ .highlight .cm { color: #888888 } /* Comment.Multiline */ .highlight .cp { color: #cc0000; font-weight: bold } /* Comment.Preproc */ .highlight .cpf { color: #888888 } /* Comment.PreprocFile */ .highlight .c1 { color: #888888 } /* Comment.Single */ .highlight .cs { color: #cc0000; font-weight: bold; background-color: #fff0f0 } /* Comment.Special */ .highlight .gd { color: #000000; background-color: #ffdddd } /* Generic.Deleted */ .highlight .ge { font-style: italic } /* Generic.Emph */ .highlight .gr { color: #aa0000 } /* Generic.Error */ .highlight .gh { color: #333333 } /* Generic.Heading */ .highlight .gi { color: #000000; background-color: #ddffdd } /* Generic.Inserted */ .highlight .go { color: #888888 } /* Generic.Output */ .highlight .gp { color: #555555 } /* Generic.Prompt */ .highlight .gs { font-weight: bold } /* Generic.Strong */ .highlight .gu { color: #666666 } /* Generic.Subheading */ .highlight .gt { color: #aa0000 } /* Generic.Traceback */ .highlight .kc { color: #008800; font-weight: bold } /* Keyword.Constant */ .highlight .kd { color: #008800; font-weight: bold } /* Keyword.Declaration */ .highlight .kn { color: #008800; font-weight: bold } /* Keyword.Namespace */ .highlight .kp { color: #008800 } /* Keyword.Pseudo */ .highlight .kr { color: #008800; font-weight: bold } /* Keyword.Reserved */ .highlight .kt { color: #888888; font-weight: bold } /* Keyword.Type */ .highlight .m { color: #0000DD; font-weight: bold } /* Literal.Number */ .highlight .s { color: #dd2200; background-color: #fff0f0 } /* Literal.String */ .highlight .na { color: #336699 } /* Name.Attribute */ .highlight .nb { color: #003388 } /* Name.Builtin */ .highlight .nc { color: #bb0066; font-weight: bold } /* Name.Class */ .highlight .no { color: #003366; font-weight: bold } /* Name.Constant */ .highlight .nd { color: #555555 } /* Name.Decorator */ .highlight .ne { color: #bb0066; font-weight: bold } /* Name.Exception */ .highlight .nf { color: #0066bb; font-weight: bold } /* Name.Function */ .highlight .nl { color: #336699; font-style: italic } /* Name.Label */ .highlight .nn { color: #bb0066; font-weight: bold } /* Name.Namespace */ .highlight .py { color: #336699; font-weight: bold } /* Name.Property */ .highlight .nt { color: #bb0066; font-weight: bold } /* Name.Tag */ .highlight .nv { color: #336699 } /* Name.Variable */ .highlight .ow { color: #008800 } /* Operator.Word */ .highlight .w { color: #bbbbbb } /* Text.Whitespace */ .highlight .mb { color: #0000DD; font-weight: bold } /* Literal.Number.Bin */ .highlight .mf { color: #0000DD; font-weight: bold } /* Literal.Number.Float */ .highlight .mh { color: #0000DD; font-weight: bold } /* Literal.Number.Hex */ .highlight .mi { color: #0000DD; font-weight: bold } /* Literal.Number.Integer */ .highlight .mo { color: #0000DD; font-weight: bold } /* Literal.Number.Oct */ .highlight .sa { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Affix */ .highlight .sb { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Backtick */ .highlight .sc { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Char */ .highlight .dl { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Delimiter */ .highlight .sd { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Doc */ .highlight .s2 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Double */ .highlight .se { color: #0044dd; background-color: #fff0f0 } /* Literal.String.Escape */ .highlight .sh { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Heredoc */ .highlight .si { color: #3333bb; background-color: #fff0f0 } /* Literal.String.Interpol */ .highlight .sx { color: #22bb22; background-color: #f0fff0 } /* Literal.String.Other */ .highlight .sr { color: #008800; background-color: #fff0ff } /* Literal.String.Regex */ .highlight .s1 { color: #dd2200; background-color: #fff0f0 } /* Literal.String.Single */ .highlight .ss { color: #aa6600; background-color: #fff0f0 } /* Literal.String.Symbol */ .highlight .bp { color: #003388 } /* Name.Builtin.Pseudo */ .highlight .fm { color: #0066bb; font-weight: bold } /* Name.Function.Magic */ .highlight .vc { color: #336699 } /* Name.Variable.Class */ .highlight .vg { color: #dd7700 } /* Name.Variable.Global */ .highlight .vi { color: #3333bb } /* Name.Variable.Instance */ .highlight .vm { color: #336699 } /* Name.Variable.Magic */ .highlight .il { color: #0000DD; font-weight: bold } /* Literal.Number.Integer.Long */
#!/bin/sh
#
# submodules.sh: init, update or list git submodules
#
# Copyright (C) 2006 Lars Hjemli
#
# Licensed under GNU General Public License v2
#   (see COPYING for full license text)
#


usage="submodules.sh [-i | -u] [-q] [--cached] [path...]"
init=
update=
quiet=
cached=


say()
{
	if test -z "$quiet"
	then
		echo -e "$@"
	fi
}


die()
{
	echo >&2 -e "$@"
	exit 1
}



#
# Silently checkout specified submodule revision, return exit status of git-checkout
#
# $1 = local path
# $2 = requested sha1
#
module_checkout()
{
	$(cd "$1" && git checkout "$2" 1>/dev/null 2>/dev/null)
}


#
# Find all (requested) submodules, run clone + checkout on missing paths
#
# $@ = requested paths (default to all)
#
modules_init()
{
	git ls-files --stage -- $@ | grep -e '^160000 ' |
	while read mode sha1 stage path
	do
		test -d "$path/.git" && continue

		if test -d "$path"
		then
			rmdir "$path" 2>/dev/null ||
			die "Directory '$path' exist, but not as a submodule"
		fi

		test -e "$path" && die "A file already exist at path '$path'"

		url=$(sed -nre "s/^$path[ \t]+//p" .gitmodules)
		test -z "$url" && die "No url found for $path in .gitmodules"

		git clone "$url" "$path" || die "Clone of submodule '$path' failed"
		module_checkout "$path" "$sha1" || die "Checkout of submodule '$path' failed"
		say "Submodule '$path' initialized"
	done
}

#
# Checkout correct revision of each initialized submodule
#
# $@ = requested paths (default to all)
#
modules_update()
{
	git ls-files --stage -- $@ | grep -e '^160000 ' |
	while read mode sha1 stage path
	do
		if ! test -d "$path/.git"
		then
			say "Submodule '$path' not initialized"
			continue;
		fi
		subsha1=$(cd "$path" && git rev-parse --verify HEAD) ||
		die "Unable to find current revision of submodule '$path'"
		if test "$subsha1" != "$sha1"
		then
			module_checkout "$path" "$sha1" ||
			die "Unable to checkout revision $sha1 of submodule '$path'"
			say "Submodule '$path' reset to revision $sha1"
		fi
	done
}

#
# List all registered submodules, prefixed with:
#  - submodule not initialized
#  + different version checked out
#
# If --cached was specified the revision in the index will be printed
# instead of the currently checked out revision.
#
# $@ = requested paths (default to all)
#
modules_list()
{
	git ls-files --stage -- $@ | grep -e '^160000 ' |
	while read mode sha1 stage path
	do
		if ! test -d "$path/.git"
		then
			say "-$sha1 $path"
			continue;
		fi
		revname=$(cd "$path" && git describe $sha1)
		if git diff-files --quiet -- "$path"
		then
			say " $sha1 $path\t($revname)"
		else
			if test -z "$cached"
			then
				sha1=$(cd "$path" && git rev-parse HEAD)
				revname=$(cd "$path" && git describe HEAD)
			fi
			say "+$sha1 $path\t($revname)"
		fi
	done
}


while case "$#" in 0) break ;; esac
do
	case "$1" in
	-i)
		init=1
		;;
	-u)
		update=1
		;;
	-q)
		quiet=1
		;;
	--cached)
		cached=1
		;;
	--)
		break
		;;
	-*)
		echo "Usage: $usage"
		exit 1
		;;
	--*)
		echo "Usage: $usage"
		exit 1
		;;
	*)
		break
		;;
	esac
	shift
done


if test "$init" = "1"
then
	modules_init $@
elif test "$update" = "1"
then
	modules_update $@
else
	modules_list $@
fi